Attribute VB_Name = "Module1"
Option Explicit



Public Const MAX_PATH As Integer = 260

' the process type
Public Type PROCESSENTRY32
    dwSize As Long                      ' Struct size
    cntUsage As Long
    th32ProcessID As Long               ' process ID
    th32DefaultHeapID As Long
    th32ModuleID As Long
    cntThreads As Long                  ' thread number
    th32ParentProcessID As Long
    pcPriClassBase As Long              ' process priority
    dwFlags As Long
    szexeFile As String * MAX_PATH
End Type

Private Type MEMORYSTATUS
    dwLength As Long
    dwMemoryLoad As Long
    dwTotalPhys As Long
    dwAvailPhys As Long
    dwTotalPageFile As Long
    dwAvailPageFile As Long
    dwTotalVirtual As Long
    dwAvailVirtual As Long
End Type

Private pUdtMemStatus As MEMORYSTATUS

Private Declare Sub GlobalMemoryStatus Lib _
"kernel32" (lpBuffer As MEMORYSTATUS)

' Constants for the counters

' to see the full list, look at the registry key :
' HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\Windows NT\CurrentVersion\Perflib\
' Choose an Id langage (OO9 : US English, OOC : French) and look at
' the number in front of each counter (or object) in "Counter"

' Objects
Public Const COUNTERPERF_SYSTEM = 2
Public Const COUNTERPERF_MEMORY = 4
Public Const COUNTERPERF_PROCESS = 230
Public Const COUNTERPERF_THREAD = 232
Public Const COUNTERPERF_PROCESSOR = 238
' Counters
Public Const COUNTERPERF_PERCENTPROCESSORTIME = 6

' the processes
Public Declare Function ProcessFirst Lib "kernel32" Alias "Process32First" (ByVal hSnapshot As Long, uProcess As PROCESSENTRY32) As Long
Public Declare Function ProcessNext Lib "kernel32" Alias "Process32Next" (ByVal hSnapshot As Long, uProcess As PROCESSENTRY32) As Long
Public Declare Function CreateToolhelpSnapshot Lib "kernel32" Alias "CreateToolhelp32Snapshot" (ByVal lFlags As Long, lProcessID As Long) As Long
Public Const TH32CS_SNAPPROCESS As Long = 2&

' Close an opened handle
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long

'syscopy
'Public Declare Function CopyFile Lib "kernel32" _
'  Alias "CopyFileA" (ByVal lpExistingFileName As String, _
'  ByVal lpNewFileName As String, ByVal bFailIfExists As Long) _
'  As Long




'get processes info
' Delete the extension of a file
Public Function GetFileNameWithoutExtension(FileName As String) As String
    Dim lDotPos As Long
    lDotPos = InStrRev(FileName, ".")
    If lDotPos = 0 Then
        GetFileNameWithoutExtension = FileName
    Else
        GetFileNameWithoutExtension = Left$(FileName, lDotPos - 1)
    End If
End Function




' List the processes running on the system
Public Sub mpListProcess(ByRef tabID() As Long)
    Dim hSnapshot   As Long
    Dim uProcess    As PROCESSENTRY32
    Dim T           As Long
    Dim Nb          As Long
    ReDim tabID(0) As Long
    ' Snaphshot of the processes
    hSnapshot = CreateToolhelpSnapshot(TH32CS_SNAPPROCESS, 0&)
    If hSnapshot = 0 Then Exit Sub
    uProcess.dwSize = Len(uProcess)
    ' the first one
    T = ProcessFirst(hSnapshot, uProcess)
    Nb = 0
    ' for each process
    Do While T
        ' save the process
        ReDim Preserve tabID(Nb) As Long
        tabID(Nb) = uProcess.th32ProcessID
        Nb = Nb + 1
        ' take the next one
        T = ProcessNext(hSnapshot, uProcess)
    Loop
    CloseHandle hSnapshot
End Sub

' Get the process name with his process ID
Public Function mpGetProcessName(ByVal ProcessID As Long) As String
    Dim hSnapshot As Long
    Dim uProcess As PROCESSENTRY32
    Dim T As Long
    hSnapshot = CreateToolhelpSnapshot(TH32CS_SNAPPROCESS, 0&)
    If hSnapshot = 0 Then Exit Function
    uProcess.dwSize = Len(uProcess)
    T = ProcessFirst(hSnapshot, uProcess)
    Do While T
        ' If that is the one we're looking for
        If uProcess.th32ProcessID = ProcessID Then
            mpGetProcessName = uProcess.szexeFile
            mpGetProcessName = Left(mpGetProcessName, InStr(mpGetProcessName, vbNullChar) - 1)
            Exit Function
        End If
        T = ProcessNext(hSnapshot, uProcess)
    Loop
End Function


Public Function AvailablePhysicalMemory() As Double
'Return Value in Megabytes
    Dim dblAns As Double
    GlobalMemoryStatus pUdtMemStatus
    dblAns = pUdtMemStatus.dwAvailPhys
    AvailablePhysicalMemory = BytesToMegabytes(dblAns)
    
End Function

Public Function TotalPhysicalMemory() As Double
'Return Value in Megabytes
    Dim dblAns As Double
    GlobalMemoryStatus pUdtMemStatus
    dblAns = pUdtMemStatus.dwTotalPhys
    TotalPhysicalMemory = BytesToMegabytes(dblAns)
End Function

Public Function PercentMemoryFree() As Double

   PercentMemoryFree = Format(AvailableMemory / TotalMemory * _
   100, "0#")
End Function

Public Function AvailablePageFile() As Double
'Return Value in Megabytes
    Dim dblAns As Double
    GlobalMemoryStatus pUdtMemStatus
    dblAns = pUdtMemStatus.dwAvailPageFile
    AvailablePageFile = BytesToMegabytes(dblAns)
End Function

Public Function PageFileSize() As Double
'Return Value in Megabytes
    Dim dblAns As Double
    GlobalMemoryStatus pUdtMemStatus
    dblAns = pUdtMemStatus.dwTotalPageFile
    PageFileSize = BytesToMegabytes(dblAns)

End Function

Public Function AvailableMemory() As Double
'Return Value in Megabytes
     AvailableMemory = AvailablePhysicalMemory + AvailablePageFile
End Function

Public Function TotalMemory() As Double
'Return Value in Megabytes
    TotalMemory = PageFileSize + TotalPhysicalMemory
End Function

Private Function BytesToMegabytes(Bytes As Double) As Double
 
  Dim dblAns As Double
  dblAns = (Bytes / 1024) / 1024
  BytesToMegabytes = Format(dblAns, "###,###,##0.00")
  
End Function


'copy file

'Public Function APIFileCopy(src As String, dest As String, _
'  Optional FailIfDestExists As Boolean) As Boolean
'
''PURPOSE: COPY FILES
''PARAMETERS: src: Source File (FullPath)
'            'dest: Destination File (FullPath)
'            'FailIfDestExists (Optional):
'            'Set to true if you don't want to
'            'overwrite the destination file if
'            'it exists
'
'            'Returns (True if Successful, false otherwise)
'
''EXAMPLE:
'  'dim bSuccess as boolean
'  'bSuccess = APIFileCopy ("C:\MyFile.txt", "D:\MyFile.txt")'
'
'Dim lRet As Long
'lRet = CopyFile(src, dest, FailIfDestExists)
'APIFileCopy = (lRet > 0)
'
'End Function
